"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Ancestries(ProtocolElement):
    """
    Ancestries, defined as Ethnic category(ies) and Chi-square test
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "chiSquare1KGenomesPhase3Pop": participant_1_0_1.ChiSquare1KGenomesPhase3Pop,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "fathersEthnicOrigin": participant_1_0_1.EthnicCategory,
            "mothersEthnicOrigin": participant_1_0_1.EthnicCategory,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "org.gel.models.participant.avro.ChiSquare1KGenomesPhase3Pop": participant_1_0_1.ChiSquare1KGenomesPhase3Pop,
            "org.gel.models.participant.avro.EthnicCategory": participant_1_0_1.EthnicCategory,
            "org.gel.models.participant.avro.EthnicCategory": participant_1_0_1.EthnicCategory,
            "org.gel.models.participant.avro.Ancestries": participant_1_0_1.Ancestries,
        }

    __slots__ = [
        "chiSquare1KGenomesPhase3Pop",
        "fathersEthnicOrigin",
        "fathersOtherRelevantAncestry",
        "mothersEthnicOrigin",
        "mothersOtherRelevantAncestry",
    ]

    def __init__(
        self,
        chiSquare1KGenomesPhase3Pop=None,
        fathersEthnicOrigin=None,
        fathersOtherRelevantAncestry=None,
        mothersEthnicOrigin=None,
        mothersOtherRelevantAncestry=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_1.Ancestries model.

        :param chiSquare1KGenomesPhase3Pop:
            Chi-square test for goodness of fit of this sample to 1000 Genomes
            Phase 3 populations
        :type chiSquare1KGenomesPhase3Pop: None | list[ChiSquare1KGenomesPhase3Pop]
        :param fathersEthnicOrigin:
            Father's Ethnic Origin
        :type fathersEthnicOrigin: None | EthnicCategory
        :param fathersOtherRelevantAncestry:
            Father's Ethnic Origin Description
        :type fathersOtherRelevantAncestry: None | str
        :param mothersEthnicOrigin:
            Mother's Ethnic Origin
        :type mothersEthnicOrigin: None | EthnicCategory
        :param mothersOtherRelevantAncestry:
            Mother's Ethnic Origin Description
        :type mothersOtherRelevantAncestry: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.1"
